/*
 *  ObjectLoader.cpp
 *  ObjectLoader
 *
 *  Created by Pierre Chatelier on 30/05/08.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

#include "ObjectLoader.h"

#include <ObjMeshParser.hpp>
#include <Logger.hpp>
#include <Mesh.hpp>

#include <string>
#include <exception>
using namespace std;

ObjMesh* meshCreateFromFile(const char* UTF8Path)
{
  boost::shared_ptr<CMesh>* mesh = new boost::shared_ptr<CMesh>(new CMesh);
  try{
    CObjMeshParser::parse(*mesh, std::string(UTF8Path));
   }
   catch(std::exception&){
   }
   catch(...){
   }
   return reinterpret_cast<ObjMesh*>(mesh);
}
//end meshCreateFromFile()

void meshDraw(CGLContextObj cgl_ctx, ObjMesh* cmesh)
{
  CGLSetCurrentContext(cgl_ctx);
  boost::shared_ptr<CMesh>* mesh = reinterpret_cast<boost::shared_ptr<CMesh>*>(cmesh);
  if (*mesh)
  {
    try{
      (*mesh)->draw();
    }
    catch(std::exception&){
    }
    catch(...){
    }
  }
}
//end meshDraw()

void meshRelease(ObjMesh** cmesh)
{
  if (cmesh)
  {
    boost::shared_ptr<CMesh>* mesh = reinterpret_cast<boost::shared_ptr<CMesh>*>(*cmesh);
    if (mesh)
      delete mesh;
    *cmesh = 0;
  }
}
//end meshRelease()
